---
title: Gramex Guide
classes: toc
prefix: Guide
...

- [Search the guide](search/)

## Table of contents

- [About Gramex](about/)
- [Install Gramex](install/)
- [Quickstart](quickstart/)
- [Gramex is a web server](server/)
- [Configurations control Gramex](config/)

## Reference

- [FunctionHandler runs Python code](functionhandler/)
- [FileHandler renders files](filehandler/)
- [FormHandler connects to data](formhandler/)
- [JSONHandler writes JSON data](jsonhandler/)
- [CaptureHandler takes screenshots](capturehandler/)
- [PPTXHandler generates PPTX](pptxhandler/)
- [Auth handlers log in users](auth/)
- [ProxyHandler proxies APIs](proxyhandler/)
- [UploadHandler uploads files](uploadhandler/)
- [ProcessHandler runs programs](processhandler/)
- [WebSocketHandler](websockethandler/)
- [TwitterRESTHandler](twitterresthandler/)
- [FacebookGraphHandler](facebookgraphhandler/)
- [UI components](uicomponents/)
- [Charts](chart/)
- [Cache requests](cache/)
- [Send emails](email/)
- [Smart alerts](alert/)
- [Schedule tasks](scheduler/)
- [Watch files](watch/)
- [Admin page](admin/)
- [View logs](logviewer/)
- [Run apps](apps/)
- [Writing handlers](handlers/)
- [Debug Gramex](debug/)
- [Release Notes](release/)
- [Python API reference](https://learn.gramener.com/gramex/gramex.html)

## Guides

- [Tips & Tricks](tips/)
- [Deployment patterns](deploy/)
- [Try out some exercises](exercises/)
- [Contributing to Gramex](contributing/)

## Demos

- [Speech recognition demo](speech/)

### Deprecated

- [DataHandler connects to data](datahandler/) - use [FormHandler](formhandler/)
- [QueryHandler runs SQL queryies](queryhandler/) - use [FormHandler](formhandler/)

## Additional links

- [Gramex roadmap](https://docs.google.com/spreadsheets/d/1D2xScjMWl29JtuuVP7PlsLM3OPJuMBr0VNvzzoR4HwQ/edit#gid=885343597)
